# coding=utf-8
# tulosta tulostusohje (i6 tulostaa taivutukset tämän avulla)
# - taivutustiedot tulee täältä: kotus-sanalista.xml
# - python 2.7 vai sittenkin 3? (väliä sillä esim sanotko input / raw_input)
# - aiheuttaako koodaus utf-8 problems kun copypasteaa UTF-8 -> ISO 8859-1
import xml.etree.ElementTree as ET
# syöte riviltä
import sys 

tree = ET.parse('kotus-sanalista_lyh.xml')
root = tree.getroot()


def _input_():
        # syötetään (tulostettava) nimi ohjelmalle
        print(sys.argv[1])
        if len(sys.argv) > 1:
                input_value = sys.argv[1]
        else:                 
                input_value = input("syötä nimi:\n")
        #print('syötit ', input_value)
        nimiluuppi(input_value)

#def onkomerkit(merkkijono):
#
#        tiheys = Counter(merkkijono)
#
#        if(len(tiheys) == len(merkkijono)):

        
        
def testi_VP(t, sana):
        if t == 0:
                t = "ERROR"
       
        print("tt "+t)
        print(sana)
        
        for a in root.findall('st'):
                teksti = a.find('s').text
                if teksti == sana:
                        for a in a.iter('av'):
                                print("av "+a.text)
        if int(t) == 2:
                return sana[-1]
        else:
                return 0

def testi_V(t, sana):
        if t == 0:
                t = "ERROR"
       
        print("tt "+t)
        print(sana)
        
        for a in root.findall('st'):
                teksti = a.find('s').text
                if teksti == sana:
                        for a in a.iter('av'):
                                print("av "+a.text)

                                                          
        if int(t) == 2:
                print("SANA "+sana)
                # ö ä y + i + e usein -> ä
                # mutta esim vierasp jne esim lyon
                if ('ö' or 'ä' or 'y') in sana:
                        return 'ä'
                else:
                        return 'a'
        else:
                return 0

        
def testi_lista(t, sana):

        # VP vokaalin pidentymä V ä ö vokaalisoint
        VP = testi_VP(t,sana)
        V = testi_V(t,sana)

        if VP == 0:
                VP = "VP_E"
        if V == 0:
                V = "V_E"
                
                
        switcher = {
                '1': ["n", "a", "n", "n"], #valO/ hälY (ota a 2. char) 
                '2': ["n", V, "n"+V, VP+"n"], #palvelu/ ill: V vok pidentymä
                '3': ["n", "ta", "na", "on"], #valtio/
                '4': ["", "", "", "", ""],
                '5': ["n", "ä", "nä", "in"], # risti/
                '6': ["", "", "", "", ""],
                '7': ["", "", "", "", ""],
                '8': ["", "", "", "", ""],
                '9': ["n", "a", "na", "an"], # kala/
                '10': ["n", "a", "na", "an"], # koira/
                '11': ["", "", "", "", ""],
                '12': ["", "", "", "", ""],
                '13': ["", "", "", "", ""],
                '14': ["", "", "", "", ""],
                '15': ["", "", "", "", ""],
                '16': ["", "", "", "", ""],
                '17': ["", "", "", "", ""],
                '18': ["", "", "", "", ""],
                '19': ["", "", "", "", ""],
                '20': ["", "", "", "", ""],
                '21': ["", "", "", "", ""],
                '22': ["", "", "", "", ""],
                '23': ["", "", "", "", ""],
                '24': ["", "", "", "", ""],
                '25': ["", "", "", "", ""],
                '26': ["", "", "", "", ""],               
                '27': ["den", "ttä", "tenä", "teen"], # kä/si, hiisi, kausi
                '28': ["", "", "", "", ""],
                '29': ["", "", "", "", ""],
                '30': ["", "", "", "", ""],
                '31': ["", "", "", "", ""],
                '32': ["", "", "", "", ""],
                '33': ["", "", "", "", ""],
                '34': ["", "", "", "", ""],
                '35': ["", "", "", "", ""],                
                '36': ["", "", "", "", ""],
                '37': ["", "", "", "", ""],
                '38': ["", "", "", "", ""], #nainen 
                '39': ["", "", "", "", ""],
                '40': ["", "", "", "", ""],
                '41': ["", "", "", "", ""],
                '42': ["", "", "", "", ""],
                '43': ["", "", "", "", ""],
                '44': ["än", "ttä", "änä", "än"], #kevä/t
                '45': ["", "", "", "", ""],
                '46': ["", "", "", "", ""],
                '47': ["", "", "", "", ""],
                '48': ["", "", "", "", ""], #hame ihme
                '49': ["", "", "", "", ""],
                '50': ["", "", "", "", ""],
                #'51': ["", "", "", "", ""],
                #'52': ["", "", "", "", ""],
                #'53': ["", "", "", "", ""],
                'A': "A",
                'D': "D",
                'J': "J"
                
        }
        return switcher.get(t, "EEEEEEError")
        

# taivutusnumero
def hae_tn_listasta(sana):

        for t in root.findall('st'):
                teksti = t.find('s').text
                if teksti == sana:
	                for t in t.iter('tn'):
                                testi_lista(t.text, sana)
                                #print ("testi:", testi(t.text))
                                return t.text
# av on astevaihtelu                       
def hae_av_listasta(sana):
          
        for a in root.findall('st'):
                teksti = a.find('s').text
                if teksti == sana:
                        for a in a.iter('av'):
                                testi_lista(a.text, sana)
                                #print ("testi:", testi(a.text))
                                return a.text 

# mistä kohtaa sana katkeaa? (ennen av)                        
def hae_av_raja_listasta(sana):

        tn = 0
        av = 0
        
        for a in root.findall('st'):
                teksti = a.find('s').text
                if teksti == sana:
                        for a in a.iter('av'):
                                testi_lista(a.text, sana)
                                #print ("testi:", testi(a.text))
                                av = a.text
        for t in root.findall('st'):
                teksti = t.find('s').text
                if teksti == sana:
	                for t in t.iter('tn'):
                                testi_lista(t.text, sana)
                                #print ("testi:", testi(t.text))
                                tn = t.text

        if(tn)=='27':
                return -2
        #if(av)=='A':
        #        return -2
        else:
                return 0
      # av on a

def nimiluuppi(input_value):
        # jos välejä ts. useampi sana nimessä, jaetaan nimi lst
        lst = input_value.split(' ')
        # n on nimen sanojen määrä
        n = len(lst)
        # sanat
        #print("nimessä sanoja ", n)
        # laskuri t        
        t = 0
        # haetaan osat

        gen_lst = 0
        par_lst = 0
        ess_lst = 0
        ill_lst = 0
        #ine_lst = [0]
        while n > t:

                jakaja = "/"
                
                sana = lst[t]

                tn = hae_tn_listasta(sana)
                
                #
                av_raja = hae_av_raja_listasta(sana)
                        
                t+=1
                # jos ei av, pitäisi "/" tulostaa loppuun
                #if(av_raja)==0:
                #        jakaja = ""
                        
                sana_ennen_av = sana[:av_raja]
                sana_jlk_av = sana[av_raja:]
                
                #print(sana_ennen_av+jakaja+sana_jlk_av, end=" ")
                sana_jaettu=(sana_ennen_av+jakaja+sana_jlk_av)

                sanat = [sana_jaettu]
                sanat.append(sana_jaettu)

                print(sana_jaettu)
                
                paatteet = testi_lista(tn,sana)
                #for paate in paatteet:
                #        paate[2]
                #print(gen)
                
                gen = paatteet[0]
                par = paatteet[1]
                ess = paatteet[2]
                ill = paatteet[3]
                #ine = paatteet[5]

                # päätteistä listat

                if gen_lst == 0:
                        gen_lst = [gen]                 
                if par_lst == 0:
                        par_lst = [par]
                if ess_lst == 0:
                        ess_lst = [ess]
                if ill_lst == 0:
                        ill_lst = [ill]
                #if ine_lst == 0:
                #ine_lst = [ine]

                gen_lst.append(gen)
                par_lst.append(par)
                ess_lst.append(ess)
                ill_lst.append(ill)
                ##ine_lst.append(ine)

        print(len(gen_lst))        
        # koska gen_lst[0] toistuu tahattomasti 1:ssä (huono), skipataan listan nollas
        print('<br> gen "', end='')
        for paate in gen_lst[1:]:
                #if paate in range (len(gen_lst[-1])):
                #print (gen_lst.index(paate))
                #print (len(gen_lst))
                #if paate in (gen_lst):
                #jakaja='/'
                #if (gen_lst.index(paate)) == (len(gen_lst)-2):   
                #        jakaja='#'
                print(paate, end=jakaja)
        print('", par "', end='')
        for paate in par_lst[1:]:
                #jakaja='/'
                #if (par_lst.index(paate)) == (len(par_lst)-1):   
                #        jakaja='##'
                print(paate, end=jakaja)
        print('", ess "', end='')
        for paate in range (len(ess_lst)):
                #jakaja='/'
                #if (ess_lst.index(paate)) == (len(ess_lst)-1):   
                #        jakaja='###'
                print(paate, end=jakaja)      
        print('", ill "', end='')
        #laskuri
        i=1
        for paate in ill_lst[1:]:
                
                #jakaja='/'
                #if (ill_lst.index(paate)) == (len(ill_lst)-1):   
                #        jakaja='####'
                #for te in range (len(ess_lst)-2):
                #if i < (len(ess_lst)):
                i+=1
                #print(i)
                #print(len(ill_lst))     
                if i>=(len(ill_lst)):        
                        jakaja=""
                print(paate, end=jakaja)
        print('",')
        #print('ine ', end='"')
        
                #print(len(gen_lst))
                #print(gen_lst[2:])
        
                #print(gen_lst[1])        
        #  esim genetiivin päätteet listasta
        #for paate in range(len(gen_lst)):
        #        print str(gen_lst)[1:-1]
                        #print(gen_lst[paate], end="/")
        #print(sanat)
_input_()
